#include "../include/useriomanager.hpp"
#include "../include/commands.hpp"

#include <iostream>
#include <jsoncpp/json/json.h>

#include <readline/readline.h>
#include <readline/history.h>


void UserIoManager::run() {
	std::cout << "UserIoManager::run() says hello!" << std::endl;

	bool keep_reading = true;
	COMMANDID cmd;
	char *line = NULL;
	while(keep_reading){
		free(line);
		
		// read an input line
		line = readline ("ccats> ");
        
		// if no input, do not add to history, and go to reading next line
		if (strlen(line) == 0) {
			continue;
		}
		
		// add the line to history
		add_history(line);
		
		cmd = getCmdIdFromString(line);
		
		switch(cmd) {
			case CMD_DISCONNECT: {
				std::printf("disconnecting\n");
				keep_reading = false;
				break;
			}
			default: {
				std::printf("unknown command %s\n", line);
			}
			case CMD_HELP: {
				std::printf("\n");
				std::printf("available COMMANDs are:\n");
				// printCmds();
				std::printf("help        - shows this help\n");
				std::printf("status      - asks the server for status\n");
				std::printf("disconnect  - closes the connection to the server\n");
				break;
			}
		}
		std::printf("\n");
	}
	free(line);
	
	return;
}
